﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Csharp_review3_delegate
{
    // (stringを一つ引数にとって、intを返すメソッドの)デリゲートを定義します。
    public delegate int MyDelegate(string arg);

    class Program
    {
        static void Main(string[] args)
        {
            // プロバイダクラスのオブジェクトを作って、
            MethodProvider obj = new MethodProvider();

            // プロバイダのメソッドを引数に、実行クラスのオブジェクトを作って、
            DriveClass drvObj = new DriveClass(obj.ClassMethod1);

            // 実行クラスを動かす
            drvObj.Run();

            // デリゲートを上書きしてみます。
            drvObj.ExtFunc = staticClassMethod;

            // 実行クラスの外からデリゲートを実行してみる
            drvObj.ExtFunc("From Main");

            Console.ReadLine();
        }

        static int staticClassMethod(string arg)
        {
            Console.WriteLine("staticClassMethod started. arg = [{0}]", arg);
            return 0;
        }
    }

    // メソッドを提供するクラス
    public class MethodProvider
    {
        public int ClassMethod1(string arg)
        {
            Console.WriteLine("ClassMethod1 started. arg = [{0}]", arg);
            return 0;
        }
    }

    // 実行者クラス
    public class DriveClass
    {
        private MyDelegate m_ExtFunc = null;
        public MyDelegate ExtFunc
        {
            get
            {
                return m_ExtFunc;
            }
            set
            {
                m_ExtFunc = value;
            }
        }

        public DriveClass(MyDelegate func)
        {
            m_ExtFunc = new MyDelegate(func);
        }

        public int Run()
        {
            int ret = 0;

            if (m_ExtFunc != null)
            {
                ret = m_ExtFunc("From DriveClass.Run()");
            }

            return ret;
        }
    }
}
